/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/*
 *  ORBit: A CORBA v2.2 ORB
 *
 *  Copyright (C) 1998 Richard H. Porter and Red Hat Software
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Phil Dawes <philipd@parallax.co.uk>
 *
 */

/*
 *   ORBit specific POA funcitons.
 *
 */

#ifndef _ORBIT_ORBIT_POA_TYPE_H_
#define _ORBIT_ORBIT_POA_TYPE_H_

#include "orbit_poa.h"

struct PortableServer_POA_type {
	struct ORBit_PseudoObject_struct parent;

	GHashTable *active_object_map;
	
	/* this'll be a hash table when I can be arsed to look up 
	   how to implement efficient hash tables  - Phil.*/
	GSList *child_POAs;     
	
	CORBA_char *the_name;
	PortableServer_POAManager the_POAManager;

	PortableServer_Servant the_servant;
};

#endif /* !_ORBIT_ORBIT_POA_TYPE_H_ */




